%%%%%% Demo for FHIM Logistic Regression on Synthetic Data %%%%%%
%%%%
%%%% Created by Sanjay at NECLA, Princeton
%%%% Date : July 2014
%%%% Version: 1.0

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % % % This demo program runs Orthant-Wise learning algorithm on Synthetic dataset. First, it generates the synthetic data by calling the function syndata_generate_logreg.m and then it runs Cross-Validation by running FHIM_Logreg_Syndata_CV.m to find the best tuning parameters (lambdas). 
% % % % Functions called in this program: syndata_generate_logreg.m , FHIM_Logreg_Syndata_CV.m
% % % % Inputs: Interactive inputs -> no. of Instances (n), no. of variables (p), rank of W (K), sparsity of beta and ak, no. of simulations to be run.
% % % % Outputs: Average Misclassification Error/Avg. ROC for FHIM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all;
close all;
clc;

%% Generate Synthetic Data
% nInstances = input('Enter number of Instances - n : ');
% pVars = input('Enter number of Variables - p : ');
% K_interactions = input('Enter rank of W (choose small integer like [1,5]) : ');
% beta_sparsity = input('Enter number of non-zeros for beta : ');
% ak_sparsity = input('Enter number of non-zeros for ak : ');
% max_simulations = input('Enter number of simulations for the experiment : ');


nInstances = 10000;
pVars = 100;
K_interactions = 2;
beta_sparsity = 10;
ak_sparsity = 10;
max_simulations = 1;

[X, Y, beta_org, W_org, epsilon] = syndata_generate_logreg(nInstances, pVars, K_interactions, beta_sparsity, ak_sparsity);


%% Run FHIM for linear regression
CV_fold =5;
param = 1;
split_percent = 0.8;
for sim=1:max_simulations
    [MSE_performance, W_est, beta_est] = FHIM_Logreg_Syndata_CV(X,Y,split_percent, CV_fold, param);
    Test_perform(sim) = MSE_performance;
end

fprintf('Avg. MSE for %d simulations is %.4f\n',max_simulations,mean(Test_perform));
