function [nll,g] = LogisticLoss_highorder_akak_Wnew_multi(ak,beta,X,y,W,W_not_ak,sk,cur_c,nClass,beta_penalty)
% % % % % beta(feature,nClass)
% % % % % X(instance,feature)
% % % % % y(instance,1)
% % % % % W(feature, feature)
% % % % % sk(1,1) sign variable control the sign of ak*ak'
% % % % % cur_c : current updating class
% Written by Sanjay Purushotham at NEC Labs, Princeton
% Modified by Yizhe Zhang at NEC Labs, Princeton, 6,10,2016 (Included sk, fixed bugs)
% Modified by Yizhe Zhang at NEC Labs, Princeton, 6,28,2016 (add multinomial regression support)
% find nll and gradient

[n,p] = size(X);
beta_penalty = beta_penalty*0;

W_temp = ak*ak'*sk;

W{cur_c} = W_not_ak + W_temp;
% modified 
W{cur_c} = W{cur_c}-diag(diag(W{cur_c}));

% instance * nclass
Xbeta = X*beta;

for i=1:n
    sum_ak_x(i) = X(i,(2:p))*ak;
end
% n * p-1
tilda_x = zeros(n,p-1);
for j=2:p
    for i=1:n
        tilda_x(i,j-1) = X(i,j)*(sum_ak_x(i)-X(i,j)*ak(j-1));
    end
end




XWX = zeros(n,nClass);
for c=2:nClass
    for i=1:n
        XWX(i,c) = X(i,(2:p))*W{c}*X(i,(2:p))';
    end
end
% exp_U exp(-U) : instance * nclass
U = Xbeta + XWX;
exp_U = exp(-U);
% normalized exp(-U) : instance * nclass
exp_U_norm = bsxfun(@rdivide, exp_U , sum(exp_U,2)); 
% reweighted tilda X : 1 * feature -1
reweight_tilda_x = sk*exp_U_norm(:,cur_c)'*tilda_x;



% y_oh : one-hot  nclass*instance 
y_oh = ind2vec(y');
% tilda_x I(y=c) 1 * feature -1
tilda_x_Iy = sk*y_oh(cur_c,:) * tilda_x;




nll = sum(sum(U.*y_oh')) + sum(log(sum(exp_U,2)));

nll = nll/n + sum(beta_penalty);

if nargout > 1
    g = tilda_x_Iy - reweight_tilda_x;
    g = g'/n;
end



