function [nll,g] = LogisticLoss_highorder_beta_Wnew_multi( beta_cur,X,y,W,beta,cur_c,nClass,ak_penalty)
% % % % % beta(feature,nClass)
% % % % % X(instance,feature)
% % % % % y(instance,1)
% % % % % W({nClass},feature, feature)

% % % % % out: g: (nclass,feature)
% Written by Sanjay Purushotham at NEC Labs, Princeton
% Modified by Yizhe Zhang at NEC Labs, Princeton, 6,10,2016 (Included sk, fixed bugs)
% Modified by Yizhe Zhang at NEC Labs, Princeton, 6,28,2016 (add multinomial regression support)
% update all beta in one time

[n,p] = size(X);
ak_penalty = ak_penalty*0;
% instance * nclass
beta(:,cur_c) = beta_cur;
Xbeta = X*beta;

XWX = zeros(n,nClass);
for c=1:nClass
    for i=1:n
        XWX(i,c) = X(i,(2:p))*W{c}*X(i,(2:p))';  %2* ?
    end
end

% exp_U exp(-U) : instance * nclass

%U{c} = bsxfun(@plus,Xbeta,XWX);
U = Xbeta + XWX;
exp_U = exp(-U);
% normalized exp(-U) : instance * nclass
exp_U_norm = bsxfun(@rdivide, exp_U , sum(exp_U,2)); 

% reweighted X : nclass * feature
reweight_x = exp_U_norm(:,cur_c)'*X;


% y_oh : one-hot  nclass*instance 
y_oh = ind2vec(y');
% X I(y=c) nclass * feature 
X_Iy = y_oh(cur_c,:) * X;



nll = sum(sum(U.*y_oh')) + sum(log(sum(exp_U,2)));

nll = nll/n+ak_penalty;
% neg grad
if nargout > 1
    g = X_Iy - reweight_x;
    g = g/n; 
    %g(1,:) = zeros(1,p);%??
    g = g';
end
