function [K_greedy, w_ak, w_beta,S_all,obj_Val_ak, best ,exit_flag] = opt_routine(nClass, cc, K_greedy, w_ak, w_beta,S_all, obj_Val_ak,best, lambda_akak, lambda_beta, lambdaVect_ak, lambdaVect_beta,loss_ak,loss_beta, optimFunc_ak, optimFunc_beta,opts, X,y, W_old, w_ak_org, W_org, beta_org,top_num,top_num_b)
    %% Some option initializations
    options = opts;
    options.order = 1;
    maxiterations = 25;
    exit_flag = 0;
    [n,p] = size(X);
    if K_greedy >2
        w_ak_diff = sum((w_ak{K_greedy-1}- w_ak{K_greedy-2}).^2);
    end
    if K_greedy >1 && all(w_ak{K_greedy-1} ==0)
        w_ak{K_greedy} = 0*w_ak{K_greedy};
        K_greedy = K_greedy -2;
        fprintf('previous ak is zero, K_greedy = %d...exiting\n',K_greedy);
        exit_flag = 1;
        return;
    elseif K_greedy>2 && all(w_ak_diff < 0.001) %% if the previous is very close to the current w_ak (w_ak_diff sanity check)
        w_ak{K_greedy} = 0;
        w_ak{K_greedy-1} = 0;
        K_greedy = K_greedy -2;
        fprintf('current ak is close to previous ak...exiting\n');
        exit_flag = 1;
        return;
    end
    
    %% Calculate value of Objective function
    Wtemp1 = W_old;
    Wtemp1{cc} = cal_Wtemp(w_ak,p,K_greedy,S_all,-1);
    
    nll = find_nll(w_beta,Wtemp1,X,y, nClass);
    nll = nll/n;
    
    w_ak_penalty = 0;
    for k=1:K_greedy
        w_ak_penalty = w_ak_penalty + lambda_akak*sum(abs(w_ak{k}));
    end
    
    
    init_nll = nll;

 
    obj_Val = nll + lambda_beta*sum(abs(w_beta)) + w_ak_penalty;
    %     nll = nll/n;
    
    % previous and current objective function values
    obj_Val_prev = obj_Val;
    obj_Val_cur = 10^100;
    
    % Some initializations
    iterations = 1;
    criterionObjective = 1;
    tolerance = 1e-12;
    curr_loss = nll;
    %Loss_val = [init_nll];
    %Loss_beta_val = [init_nll];
    best.best_loss_betaOnly = 10^100;
    best.best_loss_ak = 10^100;
    
    %% Alternating Optimization Loop, 1st optimize ak then beta
    while iterations<=maxiterations && criterionObjective > tolerance %&& obj_Val_prev <= obj_Val_cur
        
        prev_loss = curr_loss;
        
        %% OWL of ak  (for existing a_k?)
        Wtemp1 = W_old;
        Wtemp1{cc} = cal_Wtemp(w_ak,p,K_greedy,S_all,-1);
        nll = find_nll(w_beta,Wtemp1,X,y, nClass);   



        for k=1:K_greedy
            % Co-ordinate descent on a_k
            %             tic
            Wtemp1 = W_old;
            Wtemp1{cc} = cal_Wtemp(w_ak,p,K_greedy,S_all,-1);
            w_beta_penalty = sum(lambdaVect_beta.*abs(w_beta));

            % nclass
            w_ak_penalty = 0;
            for class_id = 2:nClass
                for kk=1:K_greedy
                    if kk~=k
                        w_ak_penalty = w_ak_penalty + lambda_akak*sum(abs(w_ak_org{class_id}{kk}));
                    end
                end
            end
            w_penalty = w_beta_penalty+w_ak_penalty;

            %  fprintf('\nCo-ordinate descent over a_k at k = %d\n',k);
            this_nll = 1e10; sk = 0;
            if opts.isPosDef
                s_set = [1];
            else
                s_set = [-1,1];
            end            
            for temp_sk = s_set
                W_not_ak = cal_Wtemp(w_ak,p,K_greedy,S_all,k);
                lossArgs_ak{k} = {w_beta,X,y,Wtemp1,W_not_ak, temp_sk,cc,nClass,w_penalty};
                [temp_w_ak,temp_nll] = optimFunc_ak(loss_ak, w_ak{k},lambdaVect_ak,options,lossArgs_ak{k}{:});
                % gradient check
%                 F = @(x) LogisticLoss_highorder_akak_Wnew_multi(x,w_beta,X,y,Wtemp1,W_not_ak, temp_sk,cc,nClass,w_penalty);
%                 num_g = num_grad(F,w_ak{k});
%                 [nll,g] = LogisticLoss_highorder_akak_Wnew_multi(w_ak{k},w_beta,X,y,Wtemp1,W_not_ak, temp_sk,cc,nClass,w_penalty);
                if temp_nll<this_nll
                    this_w_ak = temp_w_ak;
                    this_nll = temp_nll;
                    sk = temp_sk;
                end
            end
            w_ak{k} = this_w_ak;
            S_all(k) = sk;
                 
            %             toc
            % %             if norm(w_ak{k},2) > 0
            % %                 w_ak{k} = w_ak{k}/norm(w_ak{k},2);
            % %             end

            %fprintf('AK: norm ak = %.4f, norm W_est = %.4f, norm W_org = %.4f\n',norm(w_ak{k},2),norm(Wtemp1),norm(W_org));
            Wtemp1{cc} = cal_Wtemp(w_ak,p,K_greedy,S_all,-1);
            [F1_W2,Pr_W2,Re_W2,F1_beta2,Pr_beta2,Re_beta2,Krank_top2] = plot_supp_rcvy(cc, Wtemp1{cc},w_beta(:,cc),W_org{cc},beta_org(:,cc),top_num,top_num_b);
%             fprintf('F1_W2 = %.4f\n',F1_W2);
%             fprintf('F1_beta2 = %.4f\n',F1_beta2);
            %close all

        end

        % setting k=-1 means use all k    
        Wtemp1 = W_old;
        Wtemp1{cc} = cal_Wtemp(w_ak,p,K_greedy,S_all,-1);
        
        %% Find Loss Function Value for current ak and previous beta
        nll = find_nll(w_beta,Wtemp1,X,y, nClass);    
        loss_obj_ak = nll; % log loss
        fprintf('Loss function for ak is %12.5e witk K rank =%d at itr= %d\n',loss_obj_ak,K_greedy,iterations);
        
        
        if best.best_loss_ak > loss_obj_ak
            best.best_loss_ak = loss_obj_ak;
            best.best_ak = w_ak;
            best.best_beta_ak = w_beta;
            best.Krank_best_ak = K_greedy;
            best.best_itr_ak = iterations;
        end;
       
        
        %% OWL for beta
        Wtemp1 = W_old;
        Wtemp1{cc} = cal_Wtemp(w_ak,p,K_greedy,S_all,-1);
        % %         Co-ordinate descent on beta
        w_ak_penalty = 0;
        for class_id = 2:nClass
            for kk=1:K_greedy
                if kk~=k
                    w_ak_penalty = w_ak_penalty + lambda_akak*sum(abs(w_ak_org{class_id}{kk}));
                end
            end
        end
        
        lossArgs_beta = { X,y,Wtemp1, w_beta, cc, nClass,w_ak_penalty};
        w_beta(:,cc) = optimFunc_beta(loss_beta,w_beta(:,cc),lambdaVect_beta(:,cc),options,lossArgs_beta{:});
        
        %check grad
%         F = @(x) LogisticLoss_highorder_beta_Wnew_multi(x,X,y,Wtemp1, w_beta, cc, nClass,w_ak_penalty);
%         num_g = num_grad(F,w_beta(:,cc));
%         [nll3,g] = LogisticLoss_highorder_beta_Wnew_multi(w_beta(:,cc),X,y,Wtemp1, w_beta, cc, nClass,w_ak_penalty);
        %% Find Loss Function Value using beta only
        
        loss_obj_beta = find_nll_beta_only(w_beta,X,y);   % log loss
        %loss_obj_beta = loss_obj_beta/n;
        fprintf('Loss function for beta only is %12.5e witk K rank =%d at itr=%d\n',loss_obj_beta,K_greedy,iterations);
        

        
%         if best_loss_betaOnly > loss_obj_beta;
%             best_loss_betaOnly = loss_obj_beta;
%             best_betaOnly = w_beta;
%             Krank_best_betaOnly = K_greedy;
%             best_itr_betaOnly = iterations;
%         end
        
        %% Calculating Objective functions after convergence of OWL
        Wtemp1 = W_old;
        Wtemp1{cc} = cal_Wtemp(w_ak,p,K_greedy,S_all,-1);
        
        nll2 = find_nll(w_beta,Wtemp1,X,y, nClass);   
        %         nll2 = nll2/n;
        
        w_ak_penalty = 0;
        for k=1:K_greedy
            w_ak_penalty = w_ak_penalty + lambda_akak*sum(abs(w_ak{k}));
        end
        obj_Val = nll2 + lambda_beta*sum(sum(abs(w_beta))) + w_ak_penalty;
        obj_Val_cur = obj_Val;
        
        if obj_Val_prev ~= 0;
            criterionObjective = abs(obj_Val_cur-obj_Val_prev)/obj_Val_prev;
        else
            criterionObjective = 0;
        end
        
        fprintf('Curr. obj. val = %12.5e, Prev. obj. val = %12.5e, Criterion = %12.5e, Iteration = %d\n',obj_Val_cur, obj_Val_prev, criterionObjective, iterations);
        obj_Val_prev = obj_Val_cur;
        iterations = iterations + 1;
        [F1_W2,Pr_W2,Re_W2,F1_beta2,Pr_beta2,Re_beta2,Krank_top2] = plot_supp_rcvy(cc, Wtemp1{cc},w_beta(:,cc),W_org{cc},beta_org(:,cc),top_num,top_num_b);
%         fprintf('F1_W2 = %.4f\n',F1_W2);
%         fprintf('F1_beta2 = %.4f\n',F1_beta2);
        %close all
    end
    
%     Loss_val = [Loss_val, loss_obj_ak];
%     Loss_beta_val = [Loss_beta_val, loss_obj_beta];
    
    %% Display the Previous and Current Objective val.
    fprintf('Curr. obj. = %12.5e, Prev. obj. = %12.5e, Curr. Los. = %12.5e, Prev. Los = %12.5e, Criterion = %12.5e, Itr = %d\n',obj_Val_cur, obj_Val_prev, curr_loss,prev_loss, criterionObjective, iterations);
    %% Check conditions for greedy optimization of K
    if K_greedy == 1
        obj_Val_ak = nll2;
        %         obj_Val_ak_prev = loss_obj_ak;
        %         obj_Val_ak_cur = loss_obj_ak;
        if init_nll > nll2
            fprintf('***************************************************\n');
            fprintf('NLL at initialization (%12.5e) > NLL val at new ak{1} (%12.5e)...continuing\n',init_nll, nll2);
            fprintf('***************************************************\n');
        else
            fprintf('***************************************************\n');
            fprintf('NLL at initialization (%12.5e) < NLL val at new ak{1} (%12.5e)...continuing.. add ak\n',init_nll, nll2);
            fprintf('***************************************************\n');
        end
    else
        fprintf('***************************************************\n');
        fprintf('Added new ak, since Cur ak Obj. (%12.5e) <= Prev. ak Obj. (%12.5e)\n',nll2 ,obj_Val_ak);
        fprintf('***************************************************\n');
        obj_Val_ak = nll2;
        %         obj_Val_ak_cur = loss_obj_ak;
    end
    
    if nll2 > obj_Val_ak
        fprintf('***************************************************\n');
        fprintf('NLL of cur ak (%12.5e) > NLL at prev ak(%12.5e)...exiting\n',nll2 ,obj_Val_ak);
        fprintf('***************************************************\n');
        w_ak{K_greedy} = 0;
        K_greedy = K_greedy -1;
        exit_flag = 1;
        return;
    end
    K_greedy = K_greedy + 1;
    w_ak{K_greedy} = ones(1,p-1)';
    w_ak{K_greedy} = w_ak{K_greedy}/norm(w_ak{K_greedy},2);
    S_all = [S_all,1];
     
    [F1_W2,Pr_W2,Re_W2,F1_beta2,Pr_beta2,Re_beta2,Krank_top2] = plot_supp_rcvy(cc, Wtemp1{cc},w_beta(:,cc),W_org{cc},beta_org(:,cc),top_num,top_num_b);
    fprintf('F1_W2 = %.4f\n',F1_W2);
    fprintf('F1_beta2 = %.4f\n',F1_beta2);    
    %     pause;