function [F1_W,Pr_W,Re_W,F1_beta,Pr_beta,Re_beta,K_rank_top] = plot_supp_rcvy(cc, W_est,beta_est,W_org,beta_org,top_num,top_num_b)

% top #top_num_b of the beta
beta_est_temp=sort(abs(beta_est),'descend');
beta_est_top=(abs(beta_est)>=beta_est_temp(top_num_b)).*beta_est;
overlap_b_b1 = intersect(find(beta_est_top~=0)',find(beta_org~=0));
beta_est = beta_est_top;

%% Finding only to entries of the W_est
% % % top_num = ak_sparsity*ak_sparsity*K_interactions; % top_num = 0.05*pVars; assuming 5% sparse
W_est_temp=sort(abs(W_est(:)),'descend');
W_est_top=(abs(W_est)>=W_est_temp(top_num)).*W_est;

K_rank_top =  rank(W_est_top);

W_temp_nnz = (W_org ~=0);
W_temp1_nnz = (W_est~=0);
W_temp2_nnz = abs(W_est_top)>0;

%% Plot of support recovery of Beta and W_est
% figure,
% subplot(221), stem(beta_org), title('Original beta');
% subplot(222), stem(beta_est), title('Estimated beta');
% subplot(223), imagesc(abs(W_org)>0), colormap(gray), title('Original W');
% subplot(224), imagesc(abs(W_est_top)>0), colormap(gray), title('Estimated W');
% % % subplot(224), imagesc(abs(W_est)>0.1), colormap(gray), title('Estimated W');

overlap_W_W1 = 0;
overlap_W_W2 = 0;
for i=1:size(W_temp_nnz,1)
    for j = 1:size(W_temp_nnz,2)
        if (W_temp_nnz(i,j)~=0)
            if W_temp_nnz(i,j) == W_temp1_nnz(i,j)
                overlap_W_W1 = overlap_W_W1 + 1;
            end
            if W_temp_nnz(i,j) == W_temp2_nnz(i,j)
                overlap_W_W2 = overlap_W_W2 + 1;
            end
        end
    end
end
overlap_W_W1_recall = overlap_W_W1/sum(sum(W_temp_nnz));
overlap_W_W2_recall = overlap_W_W2/sum(sum(W_temp_nnz));

overlap_W_W1_precision = overlap_W_W1/(sum(sum(W_temp1_nnz))+0.0001);
overlap_W_W2_precision = overlap_W_W2/(sum(sum(W_temp2_nnz))+0.0001);

F1_W_W1 = 2* overlap_W_W1_recall*overlap_W_W1_precision/(overlap_W_W1_precision+overlap_W_W1_recall+0.0001);
F1_W_W2 = 2* overlap_W_W2_recall*overlap_W_W2_precision/(overlap_W_W2_precision+overlap_W_W2_recall+0.0001);

overlap = [overlap_W_W1_recall, overlap_W_W2_recall,  overlap_W_W1_precision,  overlap_W_W2_precision, F1_W_W1, F1_W_W2];

figure(1), subplot(331), stem(beta_org); title(['Original beta for class ' , num2str(cc)]);
subplot(332), stem(beta_est); title('Estimated beta');
subplot(333), stem(beta_est-beta_org); title('Difference of beta"s');
subplot(334),imagesc(W_temp_nnz),colormap(gray); title('Original W');
subplot(335),imagesc(W_temp1_nnz),colormap(gray); title('Estimated W_1');
subplot(336),imagesc(W_temp1_nnz-W_temp_nnz),colormap(gray); title('Difference of W and W1"s');
subplot(337),imagesc(W_temp2_nnz),colormap(gray); title('Estimated W_0');
subplot(338),imagesc(W_temp2_nnz-W_temp_nnz),colormap(gray); title('Difference of W and W_0"s');
subplot(339), stem([overlap]);title('Recall, Precision, F1 (W1, W0)'); set(gca,'Xtick',1:6,'XTickLabel',{'R W1', 'R W0', 'Pr W1', 'Pr W0', 'F1 W1','F1 W0'})

F1_W = F1_W_W2;
Pr_W = overlap_W_W2_precision;
Re_W = overlap_W_W2_recall;

%% Support recovery of beta
% % beta_est_temp=sort(abs(beta_est),'descend');
% % beta_est_top=(abs(beta_est)>=beta_est_temp(top_num)).*beta_est;
% % overlap_b_b1 = intersect(find(beta_est~=0)',find(beta_org~=0));

Pr_beta = length(overlap_b_b1)/sum(nnz(beta_est)+(1e-10));
Re_beta = length(overlap_b_b1)/sum(nnz(beta_org)+(1e-10));
F1_beta = 2*Pr_beta*Re_beta/(Pr_beta+Re_beta+(1e-10));
end